import os, json, ntpath, shutil

class Node():
	def __init__(self, key, data, path):
		self.key = key # must be a string
		self.data = data
		self.path = path

	def getLeft(self):
		if os.path.isdir(self.path + "left/"):
			p = self.path + "left/"
			f = [x for x in os.listdir(p) if x.endswith(".json")][0]
			obj = json.load(open(f))
			node = Node(obj["key"], obj["data"], obj["path"])
			return node
		return None

	def getRight(self):
		if os.path.isdir(self.path + "right/"):
			p = self.path + "right/"
			f = [x for x in os.listdir(p) if x.endswith(".json")][0]
			obj = json.load(open(f))
			node = Node(obj["key"], obj["data"], obj["path"])
			return node
		return None

	def getParent(self):
		p = self.path.split('/')[1:-1]
		if p[-1] != "tree":
			p = f"/{'/'.join(p[:-1])}/"
			f = [x for x in os.listdir(p) if x.endswith(".json")][0]
			obj = json.load(open(f))
			node = Node(obj["key"], obj["data"], obj["path"])
			return node
		return None

	def write(self):

		if not os.path.isdir(self.path): os.makedirs(self.path, exist_ok=True)
		f = open(self.path + self.key + ".json", "w+")
		payload = {"path": self.path, "key": self.key, "data": self.data}
		json.dump(payload, f)
		f.close()

class Entry:
	def __init__(self):
		pass

	def get(self, key, default=None):
		path = os.path.dirname(os.path.realpath(__file__)) + "/tree/"
		while 1:
			if not os.path.isdir(path):
				break
			else:
				data = path + [x for x in os.listdir(path) if x.endswith(".json")][0]
				fkey = ntpath.basename(data)[:-5]
				if fkey == key:
					obj = json.load(open(data))
					return obj["data"]
				elif key >= fkey: path += "right/"
				else: path += "left/"
		return default

	def insert(self, key, value):
		path = os.path.dirname(os.path.realpath(__file__)) + "/tree/"
		while 1:
			if not os.path.isdir(path) or not len(ld := os.listdir(path)):
				node = Node(key, value, path)
				node.write()
				return self
			else:
				data = path + [x for x in ld if x.endswith(".json")][0]
				fkey = ntpath.basename(data)[:-5]
				if fkey == key:
					node = Node(key, value, path)
					node.write()
					return self
				elif key >= fkey: path += "right/"
				else: path += "left/"

	def clean(self): # erases the "memory"
		path = os.path.dirname(os.path.realpath(__file__)) + "/tree/"
		shutil.rmtree(path)
		os.mkdir(path)